<template>
  <input
    class="flex-1 appearance-none border border-transparent w-full py-2 px-4 bg-white text-gray-700 placeholder-gray-400 shadow-md rounded-lg text-base focus:outline-none focus:ring-2 focus:ring-purple-600 focus:border-transparent mb-4"
    type="text"
    ref="inputNumberRef"
    :value="modelValue"
    @input="e => onInput(e)"
  />
</template>

<script setup>
import { defineProps, defineEmits, ref } from 'vue';

defineProps({
  modelValue: [Number, String],
  max: Number,
  min: Number,
  dataType: {
    type: String,
    default: 'int',
    validator: (value) => {
      return ['int', 'float'].indexOf(value) !== -1;
    }
  },
  decimal: {
    type: Number,
    default: 2,
    validator: (value) => {
      return value >= 0;
    }
  }
});

const inputNumberRef = ref('');
const emit = defineEmits(['update:modelValue'])

// const isSmallerMax = (num) => {
//   num = parseFloat(num);
//   if (num > props.max) {
//     return false;
//   }
//   return true;
// };

const formatNumber = (n) => {
  return n?.replace(/\D/g, '')?.replace(/\B(?=(\d{3})+(?!\d))/g, ',');
};

const isInteger = (num) => {
  const isInt = /^[1-9]+([0-9]*)$/.test(num);
  if (!isInt) return false;
  // if (props.max) {
  //   return isSmallerMax(num);
  // }
  return true;
};

const onInput = ($event) => {
  let inputValue = inputNumberRef.value?.value;
  if (isInteger(inputValue)) {
    $event.preventDefault();
  }
  // inputValue = inputValue.replace(/[^0-9]/g, '').replace(/(\..*)\./g, '$1');
  inputValue = formatNumber(inputValue);
  emit('update:modelValue', +inputValue);
};
</script>
